shape = {}

function shape.Calculate()
   local hw = shape.width / 2
   local hh = shape.height / 2
   local r = shape.filletRad
   Line(-hw, -hh + r, -hw, hh - r)
   ArcA(-hw, hh - r, -hw + r, hh - r, math.pi/2)
   Line(-hw + r, hh, hw - r, hh)
   ArcA(hw - r, hh, hw - r, hh - r, math.pi/2)
   Line(hw, hh - r, hw, -hh + r)
   ArcA(hw, -hh + r, hw - r, -hh + r, math.pi/2)
   Line(hw - r, -hh, -hw + r, -hh)
   ArcA(-hw + r, -hh, -hw + r, -hh + r, math.pi/2)

   hw = (shape.holeHoriz * (shape.holeHNo - 1)) / 2
   hh = (shape.holeVert * (shape.holeVNo - 1)) / 2
   local x = -hw
   local y = hh
   for p=1,shape.holeHNo do
      Circle(x, y, shape.holeDia)
      x = x + shape.holeHoriz
   end
   x = -hw
   y = -hh
   for p=1,shape.holeHNo do
      Circle(x, y, shape.holeDia)
      x = x + shape.holeHoriz
   end
   y = hh - shape.holeVert
   for p=2,shape.holeVNo - 1 do
      Circle(-hw, y, shape.holeDia)
      Circle(hw, y, shape.holeDia)
      y = y - shape.holeVert
   end
   if shape.ctrShape == 1 then --round
      Circle(0,0,shape.ctrDia)
   elseif shape.ctrShape == 2 then --square
      local s = shape.ctrDia / 2
      Line(-s, -s, -s, s)
      LineTo(s,s)
      LineTo(s,-s)
      LineTo(-s,-s)
   end
end

AddNumControl("width", "Ancho", sc.unitLINEAR, 100, 0.1, 10000, "width.png")
AddNumControl("height", "Altura", sc.unitLINEAR, 100, 0.1, 10000, "height.png")
AddNumControl("holeHNo", "Numero Orificios horizontales", sc.unit0DECPLACE, 2, 2, 100, "hHole.png")
AddNumControl("holeHoriz", "Espacio Orificio horizontal", sc.unitLINEAR, 80, 0.1, 10000, "hHole.png")
AddNumControl("holeVNo", "Numero Orificio vertical", sc.unit0DECPLACE, 2, 2, 100, "vHole.png")
AddNumControl("holeVert", "Espacio Orificio vertical", sc.unitLINEAR, 80, 0.1, 10000, "vHole.png")
AddNumControl("holeDia", "Diametro Orificio", sc.unitLINEAR, 10, 0.1, 10000, "holeDia.png")
AddNumControl("filletRad", "Radio Esquina", sc.unitLINEAR, 10, 0.1, 10000, "fillet.png")
AddChoiceControl("ctrShape", "Forma Orificio Central", {"Ninguno", "Redondo","Cuadrado"}, "")
AddNumControl("ctrDia", "Dimension del orificio central", sc.unitLINEAR, 10, 0.1, 10000, "")

